<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2010 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Blocks
 */
/**************************************************************************/

class categories3l_Block extends A_Block
{
/**
 * Формирование данных доступных в шаблоне.
 */

  function createData()
  {
	$this->supportCached(true);

	$module=getModuleBySection($this->section);
	$cpath=array();

	if($this->section==SECTION && A::$MAINFRAME->idcat>0)
	{ if($catrow=A::$DB->getRowById(A::$MAINFRAME->idcat,"{$this->section}_categories"))
	  { $this->Assign("category",$catrow);
	    $cpath[]=$catrow['id'];
	    while($catrow['idker']>0)
	    { $cpath[]=$catrow['idker'];
	      $catrow=A::$DB->getRowById($catrow['idker'],"{$this->section}_categories");
	    }
	  }
	}

	A::$DB->query("SELECT * FROM {$this->section}_categories WHERE idker=0 AND active='Y' ORDER BY sort");
	$categories=array();
	while($row=A::$DB->fetchRow())
	{ $row['link']=call_user_func($module."_createCategoryLink",$row['id'],$this->section);
	  $row['selected']=$this->section==SECTION && in_array($row['id'],$cpath);
	  $row['subcategories']=array();
	  A::$DB->query("SELECT * FROM {$this->section}_categories WHERE idker={$row['id']} AND active='Y' ORDER BY sort");
	  while($subrow=A::$DB->fetchRow())
	  { $subrow['link']=call_user_func($module."_createCategoryLink",$subrow['id'],$this->section);
		$subrow['selected']=$this->section==SECTION && in_array($subrow['id'],$cpath);
        $subrow['subcategories']=array();
	    A::$DB->query("SELECT * FROM {$this->section}_categories WHERE idker={$subrow['id']} AND active='Y' ORDER BY sort");
	    while($subsubrow=A::$DB->fetchRow())
	    { $subsubrow['link']=call_user_func($module."_createCategoryLink",$subsubrow['id'],$this->section);
		  $subsubrow['selected']=$this->section==SECTION && in_array($subsubrow['id'],$cpath);
		  $subrow['subcategories'][]=$subsubrow;
	    }
	    A::$DB->free();
		$row['subcategories'][]=$subrow;
	  }
	  A::$DB->free();
	  $categories[]=$row;
	}
	A::$DB->free();

	$this->Assign("categories",$categories);
  }
}